//+------------------------------------------------------------------+
//|                                                      TSrv2.0.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#define MAGICMA  00123456789

extern int BarsHistoryCount = 100;
extern double MovingAvgOscillatorLimit = 20;
extern int TakeProfit = 150;
extern double LotSize = 1;
extern bool StraddleMode = false;
extern bool PartialClose = true;
extern bool UseTradingSession1 = true;
extern int StartTradingSession1HH = 6;
extern int StopTradingSession1HH = 10;
extern bool UseTradingSession2 = false;
extern int StartTradingSession2HH = 14;
extern int StopTradingSession2HH = 18;
extern bool UseTradingSession3 = false;
extern int StartTradingSession3HH = 22;
extern int StopTradingSession3HH = 04;

//global variables
double resistance;
double support;



void CheckForClose() {
    if (!PartialClose)
      return;
    string orderTicket;
    double current_profitpoints,CloseLotSize;
    for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      
      if (OrderType() == OP_BUY || OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP)
         {
         current_profitpoints = (Bid - OrderOpenPrice()) / Point;
         if (current_profitpoints >= TakeProfit && OrderLots() == LotSize)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);  //modify to break even
            OrderClose(OrderTicket(),OrderLots()/2,Bid,3,Blue);
            }
         else if (current_profitpoints >= (TakeProfit*3))            
            {
            OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue);
            }
         } 
      else if (OrderType() == OP_SELL || OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP)
         {
         current_profitpoints =((OrderOpenPrice() - Ask) / Point);
         if (current_profitpoints >= TakeProfit && OrderLots() == LotSize)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);  //modify to break even
            OrderClose(OrderTicket(),OrderLots()/2,Ask,3,Red);
            }
         else if (current_profitpoints >= (TakeProfit*3))            
            {
            OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
            }
         }
   } //end of for loop
}

int CheckForOpenCondition()   {
   int trade_direction = 0;
   int shiftHighest = iHighest(NULL,0,MODE_HIGH,BarsHistoryCount,1);
   int shiftLowest = iLowest(NULL,0,MODE_LOW,BarsHistoryCount,1);
   resistance  = NormalizeDouble(High[shiftHighest],4);
   support = NormalizeDouble(Low[shiftLowest],4);
   datetime t_high = iTime(NULL,0,shiftHighest);
   datetime t_low = iTime(NULL,0,shiftLowest);
   double hist1 = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,1);
   double hist2 = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,2);
      
   if (hist1 > MovingAvgOscillatorLimit  && hist2 < MovingAvgOscillatorLimit  && hist1 > 0 && hist2 > 0)
      {
      //if (resistance > Ask)
        trade_direction = 1;
      }
   else if (hist1 < (-MovingAvgOscillatorLimit)  && hist2 > (-MovingAvgOscillatorLimit)&& hist1 < 0 && hist2 < 0)
      {
      //if (support < Bid)
        trade_direction = 2;
      }      
   return(trade_direction);
}
 
void CheckForOpen()  {
   int res1,res2;
   double takeprofitB,takeprofitS;
   int trade_direction = CheckForOpenCondition(); //checking trading direction 0=do not trade 1=buy 2=sell
   datetime expire = TimeCurrent()+ 8*60*60;
   
   if (!PartialClose)
      {
      takeprofitB = resistance+TakeProfit*Point;
      takeprofitS = support-TakeProfit*Point;
      }
            
   if(trade_direction == 1) {
      
      if (!StraddleMode)
         {
         res1=OrderSend(Symbol(),OP_BUYSTOP,LotSize,resistance,3,NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarsHistoryCount,1)],4),takeprofitB,"",MAGICMA,expire,Blue);
         }
      else  
         {
         res2=OrderSend(Symbol(),OP_BUYSTOP,LotSize,resistance,3,NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarsHistoryCount,1)],4),takeprofitB,"",MAGICMA,expire,Blue);
         res2=OrderSend(Symbol(),OP_SELLSTOP,LotSize,support,3,NormalizeDouble(High[iHighest(NULL,0,MODE_HIGH,20,1)],4),takeprofitS,"",MAGICMA,expire,Red);
         }    
      return;
     }
   if(trade_direction == 2) {
      if (!StraddleMode)
         {
         res1=OrderSend(Symbol(),OP_SELLSTOP,LotSize,support,3,NormalizeDouble(High[iHighest(NULL,0,MODE_HIGH,20,1)],4),takeprofitS,"",MAGICMA,expire,Red);
         }
      else  
         {
         res2=OrderSend(Symbol(),OP_SELLSTOP,LotSize,support,3,NormalizeDouble(High[iHighest(NULL,0,MODE_HIGH,20,1)],4),takeprofitS,"",MAGICMA,expire,Red);
         res2=OrderSend(Symbol(),OP_BUYSTOP,LotSize,resistance,3,NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,BarsHistoryCount,1)],4),takeprofitB,"",MAGICMA,expire,Blue);
         }
      return;
     }
   }  

int CalculateCurrentOrders(string symbol) {
   int buys=0,sells=0;
   for(int i=0;i<OrdersTotal();i++) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA) {
         if(OrderType()==OP_BUY || OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP)  buys++;
         if(OrderType()==OP_SELL || OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP) sells++;
        }
     }
   return(buys+sells);
  }    

int start() {
   Comment("Mov avg " + MovingAvgOscillatorLimit);
   if(Bars<100 || IsTradeAllowed()==false) return;
   if(CalculateCurrentOrders(Symbol())==0 && TradingSessionAllowed()) 
      CheckForOpen();
   else 
      CheckForClose();
   return(0);
  }
 

int init()
  {
   MovingAvgOscillatorLimit = MovingAvgOscillatorLimit * Point;
   return(0);
  }

bool TradingSessionAllowed()  {
   if (UseTradingSession1 == false && UseTradingSession2 == false && UseTradingSession3 == false) //if none of the parameters is set to true, trading always allowed
      return(true);
   bool allowed = false;
   datetime current_time = iTime(NULL,0,0);
   int startcheck,stopcheck;
   if (UseTradingSession1 && checkTimes(StartTradingSession1HH,StopTradingSession1HH))
      {
      allowed = true;
      }
   else if (UseTradingSession2 && checkTimes(StartTradingSession2HH,StopTradingSession2HH))
      {
      allowed = true;
      }
   else if (UseTradingSession3 && checkTimes(StartTradingSession3HH,StopTradingSession3HH))
      {
      allowed = true;
      }
   return(allowed);
}

bool checkTimes(int startP,int stopP)
   {
   datetime current_time = iTime(NULL,0,0);
   if (startP < stopP)
      {
      if (TimeHour(current_time) >= startP && TimeHour(current_time) <= stopP )
         {
         return(true);
         }
      }
   else if (startP > stopP)     
      {
      if (TimeHour(current_time) >= startP) 
         {
         return(true);
         }        
      else if (TimeHour(current_time) <= stopP) 
         {
         return(true);
         }
      }
   }


